import std.cstream;

import reflection;

class Test {
    void test_func1() { dout.writeLine("func1"); }
    void test_func2() { dout.writeLine("func2"); }
    void test_func3() { dout.writeLine("func3"); }
    int test_ignore1() { dout.writeLine("error"); return 0; }
    void test_ignore2(int i) { dout.writeLine("error"); }
    void ignore() { dout.writeLine("error"); }
}

int main(char[][] args) {
    if (args.length > 1) {
        Reflection.init(args[1]);
    }
    else {
        Reflection.init(null);
    }

    dout.writeLine("=== running tests ===");

    Test test = new Test();
    Class c = Class.forName("test_reflection.Test");
    if (c !is null) {
        foreach (Method m; c.methods) {
            dout.writeLine("found: " ~ m.name);
            if (m.name.length >= 4 && m.name[0..4] == "test" &&
                m.type.func.ret.builtin.type == Builtin.Type.VOID &&
                m.type.func.args.length == 0)
            {
                dout.writeLine("invoke: " ~ m.name);
                (cast(void (*)(Test))m.address)(test);
            }
        }
    }
    else {
        dout.writeLine("cannot get test class");
    }

    dout.writeLine("");
    dout.writeLine("=== dump all functions ===");

    foreach (char[] kc, Class c; Class.classes) {
        foreach (Method m; c.methods) {
            dout.writeLine(m.fullname);
        }
    }

    return 0;
}
